#pragma once

#include "skein/particle.h"

#include <string>
#include <map>

class ParticleMap
{
    public:
        ParticleMap() = default;
        ~ParticleMap() = default;

        // providing these as two methods keeps things unambiguous - manipulating particles
        // is just done for setup
        const Particle& getParticle(const std::string& id) const;
        const Particle& getParent(const std::string& id) const;
        const Orbit& getOrbit(const std::string& id) const;

        void setParticle(const Particle& particle);
        void setRelationship(const std::string& parentId, const std::string& childId, const Orbit& orbit);
        //void update(double time);
        void setParticleLocalVelocity(const std::string& id, double time, const glm::dvec3& velocity);

        glm::dvec3 getParticlePosition(const std::string& id) const;
        glm::dvec3 getParticleLocalPosition(const std::string& id, double time) const;
        glm::dvec3 getParticleLocalVelocity(const std::string& id, double time) const;

    private:
        std::map<std::string, Particle> _particles;
        // TODO: improve on this very vague name
        std::map<std::string, std::string> _relationships;
        std::map<std::string, Orbit> _orbits;

        //double _time;
};
