#pragma once

#include <GL/glew.h>
#include "glm/glm.hpp"

class Widget
{
public:
    // A widget is 3D cross.
    // It consists of 3 orthagonally intersecting lines.

    Widget(GLuint shaderProgram);
    void render(const float time);

    void setModelMatrix(const glm::mat4 matrix);

    ~Widget();
private:
    GLuint _vao;
    GLuint _vbo;
    GLuint _shaderProgram;
    glm::mat4 _modelMatrix;

    float _lineLength = 0.2;
    float _vertices[3*6] =
    {
        -1, 0, 0,
         1, 0, 0,
         0, 1, 0,
         0,-1, 0,
         0, 0, 1,
         0, 0,-1
    };
};
